Subject: Re: bridge: HSR support

From: Arvid Brodin <[email-masked]>
Date: Fri, 6 Jan 2012 19:11:32 +0100

Arvid Brodin wrote:
>> On Tue, 11 Oct 2011 20:25:08 +0200
>> Arvid Brodin <[email-masked]> wrote:
>>
>>> Hi,
>>>
>>> I want to add support for HSR ("High-availability Seamless Redundancy",
>>> IEC-62439-3) to the bridge code. With HSR, all connected units have two network
>>> ports and are connected in a ring. All new Ethernet packets are sent on both
>>> ports (or passed through if the current unit is not the originating unit). The
>>> same packet is never passed twice. Non-HSR units are not allowed in the ring.
>>>
>>> This gives instant, reconfiguration-free failover.
>>>
*snip*
> 
> I need to do two things:
> 
> 1) Bind two network interfaces into one (say, eth0 & eth1 => hsr0). Frames sent on
>    hsr0 should get an HSR tag (including the correct EtherType) and go out on both
>    eth0 and eth1.
> 
> 2) Ingress frames on eth0 & eth1, with EtherType 0x88fb, should be captured and 
>    handled specially (either received on hsr0 or forwarded to the other bound 
>    physical interface).
> 

I'm slowly getting there! :)

But what is net_device->header_ops->rebuild supposed to do?

Thanks,
Arvid Brodin
Enea Services Stockholm AB